%bcond_with debug

#%%global  checkout   5e19f30c998b7066edc6c7e0037d5f9f703ec6f5
#%%global  date       20170205

Name:          crawl
Summary:       Roguelike dungeon exploration game
Version:       0.19.5
Release:       1%{?dist}
# Main license : GPLv2+
# 2-clause BSD: all contributions by Steve Noonan and Jesse Luehrs
# Public Domain|CC0: most of tiles, perlin.cc, perlin.h
# The majority of Crawl's tiles and artwork are released under the CC0 license
# MIT: json.cc and worley.cc
# ASL 2.0: pcg.cc 
## According to the 'license.txt' file,
## This program can be redistribute under GPLv2+ license; MIT and BSD are GPL compatible.
License:       GPLv2+ and Public Domain and ASL 2.0
Group:         Amusements/Games
URL:           https://crawl.develz.org/
Source0:       https://github.com/crawl/crawl/archive/%{version}.zip#/%{name}-%{version}.tar.gz
Source1:       %{name}-tiles.desktop
Source2:       %{name}-tiles.png
Source3:       %{name}-tiles.appdata.xml

## These patches fix installation paths
Patch1:        %{name}_bin.patch
Patch2:        %{name}_tiles.patch

BuildRequires: advancecomp
BuildRequires: bison
BuildRequires: bitstream-vera-sans-fonts
BuildRequires: bitstream-vera-sans-mono-fonts
BuildRequires: gcc-c++
BuildRequires: desktop-file-utils
BuildRequires: dejavu-sans-fonts
BuildRequires: dejavu-sans-mono-fonts
BuildRequires: desktop-file-utils
BuildRequires: flex
BuildRequires: fontpackages-devel
BuildRequires: ImageMagick
BuildRequires: libappstream-glib
%if 0%{?fedora} > 25
BuildRequires: pkg-config
%endif
BuildRequires: pkgconfig(sqlite3)
BuildRequires: pkgconfig(sdl)
BuildRequires: pkgconfig(SDL2_image)
BuildRequires: pkgconfig(SDL2_mixer)
BuildRequires: pkgconfig(freetype2)
BuildRequires: pkgconfig(libpng)
BuildRequires: pkgconfig(ncurses)
BuildRequires: pkgconfig(ncursesw)
BuildRequires: pkgconfig(lua-5.1)
BuildRequires: pkgconfig(zlib)
BuildRequires: pngcrush

Requires: %{name}-common-data = %{version}-%{release}

%description
This is the Console (ncurses) version of %{name}.

Dungeon Crawl Stone Soup is a free roguelike game of exploration
and treasure-hunting in dungeons filled with dangerous and unfriendly
monsters in a quest for the mystifyingly fabulous Orb of Zot.

Dungeon Crawl Stone Soup has diverse species and many different character
backgrounds to choose from, deep tactical game-play, sophisticated magic,
religion and skill systems, and a grand variety of monsters to fight and
run from, making each game unique and challenging.

####################
%package common-data
Summary: Common data files of %{name}
BuildArch: noarch
Group:     Amusements/Games
Requires:  hicolor-icon-theme

%description common-data
Data files for tiles and console versions of %{name}.

####################
%package tiles
Summary:  Roguelike dungeon exploration game with tiles
Group:    Amusements/Games
Requires: %{name}-tiles-data = %{version}-%{release}

%description tiles
This is the tiles (graphical) version of %{name}.

Dungeon Crawl Stone Soup is a free roguelike game of exploration
and treasure-hunting in dungeons filled with dangerous and unfriendly
monsters in a quest for the mystifyingly fabulous Orb of Zot.

Dungeon Crawl Stone Soup has diverse species and many different character
backgrounds to choose from, deep tactical game-play, sophisticated magic,
religion and skill systems, and a grand variety of monsters to fight and
run from, making each game unique and challenging.

####################
%package tiles-data
Summary: Data files of %{name}-tiles
BuildArch: noarch
Requires: %{name}-common-data = %{version}-%{release}
Requires: bitstream-vera-sans-fonts
Requires: bitstream-vera-sans-mono-fonts
Group:    Amusements/Games

%description tiles-data
Data files of %{name}-tiles.

%prep
%setup -q -n %{name}-%{version}

## Strip all .png files 
## 'iCCP: known incorrect sRGB profile' warnings
find . -type f -name "*.png" -exec convert {} -strip {} \;

cat > crawl-ref/source/util/release_ver <<EOF
%{version}
EOF

## Remove unused/bundled files
rm -rf MSVC
rm -rf webserver

cp -a crawl-ref/source crawl-ref/crawl-tiles

%patch1 -p2 -d crawl-ref/source
%patch2 -p2 -d crawl-ref/crawl-tiles

%build
%if %{with debug}
make debug %{?_smp_mflags} -C crawl-ref/source \
%else
make %{?_smp_mflags} -C crawl-ref/source \
%endif
 CC=gcc CXX=g++ CFOPTIMIZE="%{optflags} -fPIC" \
 STDFLAG="%{optflags} -std=gnu++11 -fPIC" SOUND=y V=y MONOSPACED_FONT=y \
 EXTERNAL_LDFLAGS="%{__global_ldflags} -fPIC" NO_TRY_GOLD=y \
 PROPORTIONAL_FONT=%{_fontbasedir}/bitstream-vera/Vera.ttf \
 MONOSPACED_FONT=%{_fontbasedir}/bitstream-vera/VeraMono.ttf \
 COPY_FONTS=n TOUCH_UI=y \
 prefix=%{_prefix} DATADIR=%{_datadir}/%{name} \
 SAVEDIR="~/.crawl" SHAREDDIR=%{_datadir}/%{name}/dat

%if %{with debug}
make debug %{?_smp_mflags} -C crawl-ref/crawl-tiles \
%else
make %{?_smp_mflags} -C crawl-ref/crawl-tiles \
%endif
 CC=gcc CXX=g++ CFOPTIMIZE="%{optflags} -fPIC" \
 STDFLAG="%{optflags} -std=gnu++11 -fPIC" TILES=y SOUND=y V=y MONOSPACED_FONT=y \
 EXTERNAL_LDFLAGS="%{__global_ldflags} -fPIC" NO_TRY_GOLD=y \
 PROPORTIONAL_FONT=%{_fontbasedir}/bitstream-vera/Vera.ttf \
 MONOSPACED_FONT=%{_fontbasedir}/bitstream-vera/VeraMono.ttf \
 COPY_FONTS=n TOUCH_UI=y \
 prefix=%{_prefix} DATADIR=%{_datadir}/%{name} \
 SAVEDIR="~/.crawl" SHAREDDIR=%{_datadir}/%{name}/dat

%install
%if %{with debug}
make debug install DESTDIR=%{buildroot} -C crawl-ref/crawl-tiles \
%else
%make_install -C crawl-ref/crawl-tiles \
%endif
 CC=gcc CXX=g++ CFOPTIMIZE="%{optflags} -fPIC" \
 STDFLAG="%{optflags} -std=gnu++11 -fPIC" TILES=y SOUND=y V=y MONOSPACED_FONT=y \
 EXTERNAL_LDFLAGS="%{__global_ldflags} -fPIC" NO_TRY_GOLD=y \
 PROPORTIONAL_FONT=%{_fontbasedir}/bitstream-vera/Vera.ttf \
 MONOSPACED_FONT=%{_fontbasedir}/bitstream-vera/VeraMono.ttf \
 COPY_FONTS=n TOUCH_UI=y \
 prefix=%{_prefix} DATADIR=%{_datadir}/%{name} \
 SAVEDIR="~/.crawl" SHAREDDIR=%{_datadir}/%{name}/dat

%if %{with debug}
make debug install DESTDIR=%{buildroot} -C crawl-ref/source \
%else
%make_install -C crawl-ref/source \
%endif
 CC=gcc CXX=g++ CFOPTIMIZE="%{optflags} -fPIC" \
 STDFLAG="%{optflags} -std=gnu++11 -fPIC" SOUND=y V=y MONOSPACED_FONT=y \
 EXTERNAL_LDFLAGS="%{__global_ldflags} -fPIC" NO_TRY_GOLD=y \
 PROPORTIONAL_FONT=%{_fontbasedir}/bitstream-vera/Vera.ttf \
 MONOSPACED_FONT=%{_fontbasedir}/bitstream-vera/VeraMono.ttf \
 COPY_FONTS=n TOUCH_UI=y \
 prefix=%{_prefix} DATADIR=%{_datadir}/%{name} \
 SAVEDIR="~/.crawl" SHAREDDIR=%{_datadir}/%{name}/dat

## Instal icons
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/32x32/apps
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/512x512/apps
install -Dpm 644 crawl-ref/crawl-tiles/dat/tiles/stone_soup_icon-32x32.png %{buildroot}%{_datadir}/icons/hicolor/32x32/apps
install -Dpm 644 crawl-ref/crawl-tiles/dat/tiles/stone_soup_icon-512x512.png %{buildroot}%{_datadir}/icons/hicolor/512x512/apps

mkdir -p %{buildroot}%{_datadir}/icons/%{name}
install -pm 644 %{SOURCE2} %{buildroot}%{_datadir}/icons/%{name}

## Install desktop file
mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install %{SOURCE1} --dir=%{buildroot}%{_datadir}/applications

## Links to system's fonts
ln -sf %{_fontbasedir}/bitstream-vera/VeraMono.ttf %{buildroot}%{_datadir}/crawl/dat/tiles/VeraMono.ttf
ln -sf %{_fontbasedir}/bitstream-vera/Vera.ttf %{buildroot}%{_datadir}/crawl/dat/tiles/Vera.ttf

## Install appdata file
mkdir -p %{buildroot}%{_datadir}/appdata
install -pm 644 %{SOURCE3} %{buildroot}%{_datadir}/appdata
appstream-util validate-relax --nonet %{buildroot}%{_datadir}/appdata/*.appdata.xml

%post -n %{name}-common-data
/bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
/bin/touch --no-create %{_datadir}/icons/%{name} &>/dev/null || :

%postun -n %{name}-common-data
if [ $1 -eq 0 ] ; then
    /bin/touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
    /bin/touch --no-create %{_datadir}/icons/%{name} &>/dev/null
    /usr/bin/gtk-update-icon-cache %{_datadir}/icons/%{name} &>/dev/null || :
fi

%posttrans -n %{name}-common-data
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
/usr/bin/gtk-update-icon-cache %{_datadir}/icons/%{name} &>/dev/null || :

%files
%{_bindir}/crawl

%files common-data
%{_pkgdocdir}/
%license crawl-ref/licence.txt
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/dat/
%{_datadir}/%{name}/settings/
%exclude %{_datadir}/%{name}/dat/tiles
%{_datadir}/icons/%{name}/
%{_datadir}/icons/hicolor/32x32/apps/*.png
%{_datadir}/icons/hicolor/512x512/apps/*.png

%files tiles
%{_bindir}/crawl-tiles
%{_datadir}/applications/%{name}-tiles.desktop
%{_datadir}/appdata/%{name}-tiles.appdata.xml

%files tiles-data
%dir %{_datadir}/%{name}
%dir %{_datadir}/%{name}/dat
%{_datadir}/%{name}/dat/tiles/

%changelog
* Wed Mar 01 2017 Antonio Trande <sagitterATfedoraproject.org>  0.19.5-1
- Update to 0.19.5

* Sun Feb 05 2017 Antonio Trande <sagitterATfedoraproject.org>  0.19.4-2.20170205git5e19f3
- Patched for gcc7

* Wed Feb 01 2017 Antonio Trande <sagitterATfedoraproject.org>  0.19.4-1
- Update to 0.19.4 (bz#14179114)

* Sun Jan 22 2017 Antonio Trande <sagitterATfedoraproject.org>  0.19.3-2
- Use pkg-config on Fedora > 25

* Sun Jan 22 2017 Antonio Trande <sagitterATfedoraproject.org>  0.19.3-1
- Update to 0.19.3 (bz#1415476)

* Thu Nov 24 2016 Antonio Trande <sagitterATfedoraproject.org>  0.19.1-1
- Update to 0.19.1 (bz#1398298)

* Tue Nov 01 2016 Antonio Trande <sagitterATfedoraproject.org>  0.19.0-1
- Update to 0.19.0 (bz#1390562)
- Drop old patch
- Use -std=gnu++11 instead of -std=c++11 (build issue on PPC64le)

* Wed Sep 07 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-9
- Rebuild without NOWIZARD option (bz#1372480)

* Fri Sep 02 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-8
- Rebuild in nowizard mode (bz#1372480)

* Fri Jul 15 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-7
- Fix Crawl Tiles name (bz#1357087)

* Fri Jul 15 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-6
- Fix crawl-tiles's dependencies (bz#1357067)

* Sun Jun 12 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-5
- Remove unused/bundled files
- License clarification
- Compile debugging files and make Crawl tests

* Sat Jun 11 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-4
- Include MIT license
- Fix scriptlets for icons

* Mon Jun 06 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-3
- Add an appdata file

* Sat Jun 04 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-2
- Patched to fix the installation paths

* Sat Jun 04 2016 Antonio Trande <sagitterATfedoraproject.org>  0.18.1-1
- First package
